/********************* COPYRIGHT  **********************
* File Name        : if_port.h
* Author           : Levetop Electronics
* Version          : V1.0
* Date             : 2017-9-11
* Description      : ѡͬӿ
********************************************************/

#ifndef _if_port_h
#define _if_port_h
#include "sys.h"      // STM32ͷļ

//-------- ֻܿһ ----------
#define STM32_FSMC_8  0     // ʹSTM32FSMCLT768(STM32Ӳģ8080(8λ))
#define STM32_FSMC_16 1     // ʹSTM32FSMCLT768(STM32Ӳģ8080(16λ))
#define STM32_SPI     0     // ʹSTM32SPILT768
#define STM32_IIC     0     // ʹSTM32IICLT768


//ѡ8λ8080
#if STM32_FSMC_8
#define LCD_BASE0        	  ((u32)0x60000000)
#define LCD_BASE1        	  ((u32)0x60010000)
#endif

//ѡ16λ8080
#if STM32_FSMC_16
#define LCD_BASE0        	  ((u32)0x60000000)
#define LCD_BASE1        	  ((u32)0x60020000)
#endif

//ѡSPI
#if STM32_SPI
#define SS_RESET     (GPIOB->ODR &= ~(1<<12))
#define SS_SET       (GPIOB->ODR |= (1<<12))
#endif


//ѡIIC
#if STM32_IIC

#define LT_ADDR 0x3C  // LT768Ϊ豸ӦIICַIICĵַLT768I2CA[0~5]I2CA[0~5]ƽ001111

#define SDA_IN()  {GPIOB->CRH&=0XFF0FFFFF;GPIOB->CRH|=(u32)8<<20;}
#define SDA_OUT() {GPIOB->CRH&=0XFF0FFFFF;GPIOB->CRH|=(u32)3<<20;}
#define IIC_SCL_SET    (GPIOB->ODR |= (1<<12))
#define IIC_SCL_RESET  (GPIOB->ODR &= ~(1<<12))
#define IIC_SDA_SET    (GPIOB->ODR |= (1<<13))
#define IIC_SDA_RESET  (GPIOB->ODR &= ~(1<<13))
#define READ_SDA   	   ((GPIOB->IDR >> 13) & 1)
#endif



void Parallel_Init(void);

void LCD_CmdWrite(u8 cmd);
void LCD_DataWrite(u8 data);
void LCD_DataWrite_Pixel(u16 data);
u8 LCD_StatusRead(void);
u16 LCD_DataRead(void);
	 
void Delay_us(u16 time);     // ʱus
void Delay_ms(u16 time);     // ʱms






#endif
