/********************* COPYRIGHT  **********************
* File Name        : if_port.c
* Author           : Levetop Electronics
* Version          : V1.0
* Date             : 2017-9-11
* Description      : ͬӿ
********************************************************/

#include "if_port.h"

// -------------------------------------------------------- 8λ8080 --------------------------------------------------------------

#if STM32_FSMC_8
	  
// ʼFSMC
// FSMCSTM32F103ϵ100ϵĲе裬Ӳģ8080߽ӿڡ(8λ)
void FSMC_Init_8(void)
{ 					
 	GPIO_InitTypeDef GPIO_InitStructure;
	FSMC_NORSRAMInitTypeDef  FSMC_NORSRAMInitStructure;
	FSMC_NORSRAMTimingInitTypeDef  readWriteTiming; 
	FSMC_NORSRAMTimingInitTypeDef  writeTiming;
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC,ENABLE);		 //ʹFSMCʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE|RCC_APB2Periph_GPIOG,ENABLE);//ʹPORTB,D,E,GԼAFIOùʱ
	
 	//PORTD  		
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_14|GPIO_Pin_15;				 	//PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOD, &GPIO_InitStructure); 
  	 
	//PORTE  
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10;				 //	//PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOE, &GPIO_InitStructure);    	    	 

   	//PORTG12 A0	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_11;	 //PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOD, &GPIO_InitStructure); 

	readWriteTiming.FSMC_AddressSetupTime = 0x01;	 //ַʱ䣨ADDSETΪ2HCLK 1/36M=27ns
	readWriteTiming.FSMC_AddressHoldTime = 0x00;	 //ַʱ䣨ADDHLDģʽAδõ	
	readWriteTiming.FSMC_DataSetupTime = 0x01;		 // ݱʱΪ16HCLK,ΪҺICĶݵʱٶȲ̫죬1289IC
	readWriteTiming.FSMC_BusTurnAroundDuration = 0x00;
	readWriteTiming.FSMC_CLKDivision = 0x00;
	readWriteTiming.FSMC_DataLatency = 0x00;
	readWriteTiming.FSMC_AccessMode = FSMC_AccessMode_A;	 //ģʽA 
    
	writeTiming.FSMC_AddressSetupTime = 0x01;	 //ַʱ䣨ADDSETΪ1HCLK  
	writeTiming.FSMC_AddressHoldTime = 0x00;	 //ַʱ䣨A		
	writeTiming.FSMC_DataSetupTime = 0x01;		 ////ݱʱΪ4HCLK	
	writeTiming.FSMC_BusTurnAroundDuration = 0x00;
	writeTiming.FSMC_CLKDivision = 0x00;
	writeTiming.FSMC_DataLatency = 0x00;
	writeTiming.FSMC_AccessMode = FSMC_AccessMode_A;	 //ģʽA 

	FSMC_NORSRAMInitStructure.FSMC_Bank = FSMC_Bank1_NORSRAM1;//  ʹNE4 ҲͶӦBTCR[6],[7]
	FSMC_NORSRAMInitStructure.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable; // ݵַ
	FSMC_NORSRAMInitStructure.FSMC_MemoryType =FSMC_MemoryType_NOR;// FSMC_MemoryType_SRAM;  //SRAM   
	FSMC_NORSRAMInitStructure.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_8b;//洢ݿΪ8bit   
	FSMC_NORSRAMInitStructure.FSMC_BurstAccessMode =FSMC_BurstAccessMode_Disable;// FSMC_BurstAccessMode_Disable; 
	FSMC_NORSRAMInitStructure.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
	FSMC_NORSRAMInitStructure.FSMC_AsynchronousWait=FSMC_AsynchronousWait_Disable;  //--------
	FSMC_NORSRAMInitStructure.FSMC_WrapMode = FSMC_WrapMode_Disable;   
	FSMC_NORSRAMInitStructure.FSMC_WaitSignalActive = FSMC_WaitSignalActive_DuringWaitState;  
	FSMC_NORSRAMInitStructure.FSMC_WriteOperation = FSMC_WriteOperation_Enable;	//  洢дʹ
	FSMC_NORSRAMInitStructure.FSMC_WaitSignal = FSMC_WaitSignal_Enable;   
	FSMC_NORSRAMInitStructure.FSMC_ExtendedMode = FSMC_ExtendedMode_Enable; // дʹòͬʱ
	FSMC_NORSRAMInitStructure.FSMC_WriteBurst = FSMC_WriteBurst_Disable; 
	FSMC_NORSRAMInitStructure.FSMC_ReadWriteTimingStruct = &readWriteTiming; //дʱ
	FSMC_NORSRAMInitStructure.FSMC_WriteTimingStruct = &writeTiming;  //дʱ

	FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure);  //ʼFSMC

 	FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM1, ENABLE);  // ʹBANK1 
}

void FMSC_8_CmdWrite(u8 cmd)
{
	*(vu8*) (LCD_BASE0)= (cmd);
}

void FMSC_8_DataWrite(u8 data)
{
	*(vu8*) (LCD_BASE1)= (data);
}

void FMSC_8_DataWrite_Pixel(u16 data)
{
	*(vu8*) (LCD_BASE1)= (data);
	*(vu8*) (LCD_BASE1)= (data>>8);
}

u8 FMSC_8_StatusRead(void)
{
	u8 temp = 0;
	temp = *(vu8*)(LCD_BASE0);
	return temp;
}

u16 FMSC_8_DataRead(void)
{
	u16 temp = 0;
	temp =  *(vu8*)(LCD_BASE1);
	return temp;
}


#endif
	  

// -------------------------------------------------------- 16λ8080 -------------------------------------------------------------


#if STM32_FSMC_16
	  
// ʼFSMC
// FSMCSTM32F103ϵ100ϵĲе裬Ӳģ8080߽ӿڡ(16λ)
void FSMC_Init_16(void)
{ 					
 	GPIO_InitTypeDef GPIO_InitStructure;
	FSMC_NORSRAMInitTypeDef  FSMC_NORSRAMInitStructure;
	FSMC_NORSRAMTimingInitTypeDef  readWriteTiming; 
	FSMC_NORSRAMTimingInitTypeDef  writeTiming;
	
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC,ENABLE);	//ʹFSMCʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOD|RCC_APB2Periph_GPIOE|RCC_APB2Periph_GPIOG,ENABLE);//ʹPORTB,D,E,GԼAFIOùʱ
	
 	//PORTD  
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_4|GPIO_Pin_5|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_14|GPIO_Pin_15;				 //	//PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOD, &GPIO_InitStructure); 
  	 
	//PORTE  
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_8|GPIO_Pin_9|GPIO_Pin_10|GPIO_Pin_11|GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;				 //	//PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOE, &GPIO_InitStructure);    	    	 											 

   	//PORTG12 A0	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_11;	 //PORTD  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 		 //   
 	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOD, &GPIO_InitStructure); 

	readWriteTiming.FSMC_AddressSetupTime = 0x01;	 //ַʱ䣨ADDSETΪ2HCLK 1/36M=27ns
	readWriteTiming.FSMC_AddressHoldTime = 0x00;	 //ַʱ䣨ADDHLDģʽAδõ	
	readWriteTiming.FSMC_DataSetupTime = 0x01;		 // ݱʱΪ16HCLK,ΪҺICĶݵʱٶȲ̫죬1289IC
	readWriteTiming.FSMC_BusTurnAroundDuration = 0x00;
	readWriteTiming.FSMC_CLKDivision = 0x00;
	readWriteTiming.FSMC_DataLatency = 0x00;
	readWriteTiming.FSMC_AccessMode = FSMC_AccessMode_A;	 //ģʽA 
    
	writeTiming.FSMC_AddressSetupTime = 0x01;	 //ַʱ䣨ADDSETΪ1HCLK  
	writeTiming.FSMC_AddressHoldTime = 0x00;	 //ַʱ䣨A		
	writeTiming.FSMC_DataSetupTime = 0x01;		 ////ݱʱΪ4HCLK	
	writeTiming.FSMC_BusTurnAroundDuration = 0x00;
	writeTiming.FSMC_CLKDivision = 0x00;
	writeTiming.FSMC_DataLatency = 0x00;
	writeTiming.FSMC_AccessMode = FSMC_AccessMode_A;	 //ģʽA 
 
	FSMC_NORSRAMInitStructure.FSMC_Bank = FSMC_Bank1_NORSRAM1;//  ʹNE4 ҲͶӦBTCR[6],[7]
	FSMC_NORSRAMInitStructure.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable; // ݵַ
	FSMC_NORSRAMInitStructure.FSMC_MemoryType =FSMC_MemoryType_NOR;// FSMC_MemoryType_SRAM;  //SRAM   
	FSMC_NORSRAMInitStructure.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_16b;//洢ݿΪ16bit   
	FSMC_NORSRAMInitStructure.FSMC_BurstAccessMode =FSMC_BurstAccessMode_Disable;// FSMC_BurstAccessMode_Disable; 
	FSMC_NORSRAMInitStructure.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
	FSMC_NORSRAMInitStructure.FSMC_AsynchronousWait=FSMC_AsynchronousWait_Disable;  //--------
	FSMC_NORSRAMInitStructure.FSMC_WrapMode = FSMC_WrapMode_Disable;   
	FSMC_NORSRAMInitStructure.FSMC_WaitSignalActive = FSMC_WaitSignalActive_DuringWaitState;  
	FSMC_NORSRAMInitStructure.FSMC_WriteOperation = FSMC_WriteOperation_Enable;	//  洢дʹ
	FSMC_NORSRAMInitStructure.FSMC_WaitSignal = FSMC_WaitSignal_Enable;   
	FSMC_NORSRAMInitStructure.FSMC_ExtendedMode = FSMC_ExtendedMode_Enable; // дʹòͬʱ
	FSMC_NORSRAMInitStructure.FSMC_WriteBurst = FSMC_WriteBurst_Disable; 
	FSMC_NORSRAMInitStructure.FSMC_ReadWriteTimingStruct = &readWriteTiming; //дʱ
	FSMC_NORSRAMInitStructure.FSMC_WriteTimingStruct = &writeTiming;  //дʱ

	FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure);  //ʼFSMC

 	FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM1, ENABLE);  // ʹBANK1 
}

void FMSC_16_CmdWrite(u8 cmd)
{
	*(vu16*) (LCD_BASE0)= (cmd);
}

void FMSC_16_DataWrite(u8 data)
{
	*(vu16*) (LCD_BASE1)= (data);
}

void FMSC_16_DataWrite_Pixel(u16 data)
{
	*(vu16*) (LCD_BASE1)= (data);
}

u8 FMSC_16_StatusRead(void)
{
	u8 temp = 0;
	temp = *(vu16*)(LCD_BASE0);
	return temp;
}

u16 FMSC_16_DataRead(void)
{
	u16 temp = 0;
	temp =  *(vu16*)(LCD_BASE1);
	return temp;
}
#endif


// ------------------------------------------------------------ SPI --------------------------------------------------------------------

#if STM32_SPI

void SPI2_Init(void)
{
	GPIO_InitTypeDef  GPIO_InitStructure;
	SPI_InitTypeDef  SPI_InitStructure;
 
	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOB, ENABLE );//PORTBʱʹ 
	RCC_APB1PeriphClockCmd(	RCC_APB1Periph_SPI2,  ENABLE );//SPI2ʱʹ 	
 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  //PB13/14/15 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);//ʼGPIOB
 	GPIO_SetBits(GPIOB,GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15);  //PB13/14/15
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;  // PB12  
 	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;  //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
 	GPIO_Init(GPIOB, &GPIO_InitStructure);
 	GPIO_SetBits(GPIOB,GPIO_Pin_12);

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //SPI˫ģʽ:SPIΪ˫˫ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//SPIģʽ:ΪSPI
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;		//SPIݴС:SPIͽ8λ֡ṹ
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;		//ͬʱӵĿ״̬Ϊߵƽ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;	//ͬʱӵĵڶأ½ݱ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		//NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_2;		//岨ԤƵֵ:ԤƵֵΪ256
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	//ָݴMSBλLSBλʼ:ݴMSBλʼ
	SPI_InitStructure.SPI_CRCPolynomial = 7;	//CRCֵĶʽ
	SPI_Init(SPI2, &SPI_InitStructure);  //SPI_InitStructָĲʼSPIxĴ
 
	SPI_Cmd(SPI2, ENABLE); //ʹSPI	
}

u16 SPI2_ReadWriteByte(u16 TxData)
{		
	u16 retry=0;				 
	while((SPI2->SR&1<<1)==0)		//ȴ	
	{
		retry++;
		if(retry>=0XFFFE)return 0; 	//ʱ˳
	}			  
	SPI2->DR=TxData;	 	  		//һbyte 
	retry=0;
	while((SPI2->SR&1<<0)==0) 		//ȴһbyte  
	{
		retry++;
		if(retry>=0XFFFE)return 0;	//ʱ˳
	}	  						    
	return SPI2->DR;          		//յ					    
}

void SPI_CmdWrite(u8 cmd)
{
	SS_RESET; 	      
	SPI2_ReadWriteByte(0x00);
	SPI2_ReadWriteByte(cmd);
	SS_SET;
}

void SPI_DataWrite(u8 data)
{
	SS_RESET; 	      
	SPI2_ReadWriteByte(0x80);
	SPI2_ReadWriteByte(data);
	SS_SET;
}

void SPI_DataWrite_Pixel(u16 data)
{
	SS_RESET; 	      
	SPI2_ReadWriteByte(0x80);
	SPI2_ReadWriteByte(data);
	SS_SET;
	
	SS_RESET;
	SPI2_ReadWriteByte(0x80);
	SPI2_ReadWriteByte(data>>8);
	SS_SET;
}

u8 SPI_StatusRead(void)
{
	u8 temp = 0;
	SS_RESET; 	      
	SPI2_ReadWriteByte(0x40);
	temp = SPI2_ReadWriteByte(0xff);
	SS_SET;
	return temp;
}

u16 SPI_DataRead(void)
{
	u16 temp = 0;
	SS_RESET; 	      
	SPI2_ReadWriteByte(0xc0);
	temp = SPI2_ReadWriteByte(0xff);
	SS_SET;
	return temp;
}
#endif


// ------------------------------------------------------------ IIC --------------------------------------------------------------------

#if STM32_IIC
void delay(void)
{
	__ASM("NOP");
}
 
//ʼIIC
void IIC_Init(void)
{					     
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOB, ENABLE );	
	   
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12|GPIO_Pin_13;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP ; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_SetBits(GPIOB,GPIO_Pin_12|GPIO_Pin_13); 	
}
//IICʼź
void IIC_Start(void)
{
	SDA_OUT();     //sda
	IIC_SDA_SET;	  	  
	IIC_SCL_SET;
	delay();
 	IIC_SDA_RESET;//START:when CLK is high,DATA change form high to low 
	delay();
	IIC_SCL_RESET;//ǯסI2Cߣ׼ͻ 
}	  
//IICֹͣź
void IIC_Stop(void)
{
	SDA_OUT();//sda
	IIC_SCL_RESET;
	IIC_SDA_RESET;//STOP:when CLK is high DATA change form low to high
 	delay();
	IIC_SCL_SET; 
	IIC_SDA_SET;//I2C߽ź
	delay();							   	
}
//ȴӦźŵ
//ֵ1Ӧʧ
//        0Ӧɹ
u8 IIC_Wait_Ack(void)
{
	u8 ucErrTime=0;
	SDA_IN();      //SDAΪ  
	IIC_SDA_SET;delay();   
	IIC_SCL_SET;delay();	 
	while(READ_SDA)
	{
		ucErrTime++;
		if(ucErrTime>250)
		{
			IIC_Stop();
			return 1;
		}
	}
	IIC_SCL_RESET;//ʱ0 	   
	return 0;  
} 
//ACKӦ
void IIC_Ack(void)
{
	IIC_SCL_RESET;
	SDA_OUT();
	IIC_SDA_RESET;
	delay();
	IIC_SCL_SET;
	delay();
	IIC_SCL_RESET;
}
//ACKӦ		    
void IIC_NAck(void)
{
	IIC_SCL_RESET;
	SDA_OUT();
	IIC_SDA_SET;
	delay();
	IIC_SCL_SET;
	delay();
	IIC_SCL_RESET;
}					 	

//IICһֽ
//شӻӦ
//1Ӧ
//0Ӧ			  
void IIC_Send_Byte(u8 txd)
{                        
    u8 t;   
	SDA_OUT(); 	    
    IIC_SCL_RESET;//ʱӿʼݴ
    for(t=0;t<8;t++)
    {              
		if((txd&0x80)>>7)
			IIC_SDA_SET;
		else
			IIC_SDA_RESET;
		txd<<=1; 	  
		IIC_SCL_SET; 
		delay();
		IIC_SCL_RESET;	
		delay();
    }	 
} 	    
//1ֽڣack=1ʱACKack=0nACK   
u8 IIC_Read_Byte(unsigned char ack)
{
	unsigned char i,receive=0;
	SDA_IN();//SDAΪ
    for(i=0;i<8;i++ )
	{
        IIC_SCL_RESET; 
        delay();
		IIC_SCL_SET;
        receive<<=1;
        if(READ_SDA)receive++;   
		delay(); 
    }					 
    if (!ack)
        IIC_NAck();//nACK
    else
        IIC_Ack(); //ACK   
    return receive;
}

u8 IIC_CmdWrite(u8 cmd)
{
	IIC_Start(); 
	IIC_Send_Byte(LT_ADDR);
	if(IIC_Wait_Ack())	//ȴӦ
	{
		IIC_Stop();		 
		return 1;		
	}
    IIC_Send_Byte(cmd);	
	if(IIC_Wait_Ack())	//ȴACK
	{
		IIC_Stop();	 
		return 1;		 
	}		 
    IIC_Stop();	 
	return 0;
}

u8 IIC_DataWrite(u8 data)
{
	IIC_Start(); 
	IIC_Send_Byte(LT_ADDR|0x02);
	if(IIC_Wait_Ack())	//ȴӦ
	{
		IIC_Stop();		 
		return 1;		
	}
    IIC_Send_Byte(data);	
	if(IIC_Wait_Ack())	//ȴACK
	{
		IIC_Stop();	 
		return 1;		 
	}		 
    IIC_Stop();	 
	return 0;
}

void IIC_DataWrite_Pixel(u16 data)
{
	IIC_DataWrite(data);
	IIC_DataWrite(data>>8);
}

u8 IIC_StatusRead(void)
{
	u8 res;
    IIC_Start(); 
	IIC_Send_Byte(LT_ADDR|0x01);	
	IIC_Wait_Ack();			
	res=IIC_Read_Byte(0);
	IIC_NAck();
    IIC_Stop();		
	return res;		
}

u8 IIC_DataRead(void)
{
	u8 res;
    IIC_Start(); 
	IIC_Send_Byte(LT_ADDR|0x03);	
	IIC_Wait_Ack();			
	res=IIC_Read_Byte(0);
	IIC_NAck();
    IIC_Stop();		
	return res;
}
#endif


//-----------------------------------------------------------------------------------------------------------------------------------

void LCD_CmdWrite(u8 cmd)
{
	#if STM32_FSMC_8
	FMSC_8_CmdWrite(cmd);
	#endif
	
	#if STM32_FSMC_16
	FMSC_16_CmdWrite(cmd);
	#endif
	
	#if STM32_SPI
	SPI_CmdWrite(cmd);
	#endif
	
	#if STM32_IIC
	IIC_CmdWrite(cmd);
	#endif
}

void LCD_DataWrite(u8 data)
{
	#if STM32_FSMC_8
	FMSC_8_DataWrite(data);
	#endif
	
	#if STM32_FSMC_16
	FMSC_16_DataWrite(data);
	#endif
	
	#if STM32_SPI
	SPI_DataWrite(data);
	#endif
	
	#if STM32_IIC
	IIC_DataWrite(data);
	#endif
}

void LCD_DataWrite_Pixel(u16 data)
{
	#if STM32_FSMC_8
	FMSC_8_DataWrite_Pixel(data);
	#endif
	
	#if STM32_FSMC_16
	FMSC_16_DataWrite_Pixel(data);
	#endif
	
	#if STM32_SPI
	SPI_DataWrite_Pixel(data);
	#endif
	
	#if STM32_IIC
	IIC_DataWrite_Pixel(data);
	#endif
}


u8 LCD_StatusRead(void)
{
	u8 temp = 0;
	
	#if STM32_FSMC_8
	temp = FMSC_8_StatusRead();
	#endif
	
	#if STM32_FSMC_16
	temp = FMSC_16_StatusRead();
	#endif
	
	#if STM32_SPI
	temp = SPI_StatusRead();
	#endif
	
	#if STM32_IIC
	temp = IIC_StatusRead();
	#endif
	
	return temp;
}

u16 LCD_DataRead(void)
{
	u16 temp = 0;
	
	#if STM32_FSMC_8
	temp = FMSC_8_DataRead();
	#endif
	
	#if STM32_FSMC_16
	temp =  *(vu16*)(LCD_BASE1);
	#endif
	
	#if STM32_SPI
	temp = SPI_DataRead();
	#endif
	
	#if STM32_IIC
	temp = IIC_DataRead();
	#endif
	
	return temp;
}
	  
	 
void Delay_us(u16 time)
{    
   u16 i=0;  
   while(time--)
   {
      i=12;        //Լ
      while(i--) ;    
   }
}

void Delay_ms(u16 time)
{    
   u16 i=0;  
   while(time--)
   {
      i=12000;    //Լ
      while(i--) ;    
   }
}


void Parallel_Init(void)
{
	#if STM32_FSMC_8
		FSMC_Init_8();
	#endif
		
	#if STM32_FSMC_16
		FSMC_Init_16();
	#endif
	
	#if STM32_SPI
		SPI2_Init();
	#endif
	
	#if STM32_IIC
		IIC_Init();
	#endif
}
















